/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef ANTI_ENTROPY_HPP
#define ANTI_ENTROPY_HPP

#include <ctime>
#include <stdint.h>
#include <sstream>

#include "server_comm.hpp"

class AE_queue;
class AE_segment_queue;
class Segment_map;

const struct timespec SLEEP_AFTER_AE = { 10, 0 /*ns*/ };

struct ae_respond_args {
	ae_respond_args(AE_queue &queue, Segment_map &seg_map) :
		queue(queue),
		seg_map(seg_map)
	{}

	AE_queue &queue;
	Segment_map &seg_map;
};
void	*ae_respond(void *voidarg);

struct ae_active_args {
	ae_active_args(AE_segment_queue &seg_queue, Segment_map &seg_map, Segment_owner_map &segment_owner_map) :
		seg_queue(seg_queue),
		seg_map(seg_map),
		segment_owner_map(segment_owner_map)
	{}

	AE_segment_queue &seg_queue;
	Segment_map &seg_map;
	Segment_owner_map &segment_owner_map;
};
void	*ae_active(void *voidarg);

#endif
