/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef CLIENTD_WORKER_HPP
#define CLIENTD_WORKER_HPP

#include <ctime>

#include "clientd_view.hpp"
#include "clientd_queue.hpp"

// time to sleep after making N failed requests with N servers (sec, nsec)
const struct timespec SLEEP_ALLFAIL = { 0, 500 * 1000 * 1000 };

struct clientd_worker_args {
	clientd_worker_args(Clientd_queue &queue, Clientd_host_view &view,
	    Segment_owner_map &owner_map, unsigned worker_number) :
		queue(queue),
		view(view),
		owner_map(owner_map),
		worker_number(worker_number)
	{}

	Clientd_queue		&queue;
	Clientd_host_view	&view;
	Segment_owner_map	&owner_map;
	unsigned		worker_number;

};
void	*clientd_worker(void *voidargs);

#endif
