/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef HEARTBEAT_HPP
#define HEARTBEAT_HPP

#include <netinet/in.h>

#include <ctime>
#include <vector>
#include <stdint.h>

#include "server_table.hpp"

const struct timespec HEARTBEAT_INTERVAL = { 0, 500 * 1000 * 1000 }; // .5 s
const uint64_t HEARTBEAT_TOLERANCE = 1250ULL * 1000 * 1000; // 1.25 s

struct heartbeat_monitor_args {
	heartbeat_monitor_args(Server_table &servers) :
		servers(servers)
	{}

	Server_table &servers;
};
void	*heartbeat_monitor(void *voidarg);

struct heartbeat_maker_args {
	heartbeat_maker_args(Server_table &servers) :
		servers(servers)
	{}

	Server_table &servers;
};

void	*heartbeat_maker(void *voidarg);

struct heartbeat {
	uint64_t timestamp;
	uint16_t port;
	uint8_t __padding[2];
};

#endif
