/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef SERVER_COMM_HPP
#define SERVER_COMM_HPP

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#include <string>

#include "errors.hpp"

void	send_put_server(const std::string &message, int socket)
		throw (unix_error);
		
void	send_put_server_n(const char * message, size_t total, int socket)
		throw (unix_error);
		
int	send_to_addr(const std::string &message, const sockaddr_in * addr)
		throw (unix_error);
		
int	send_to_addr_n(const char * message, unsigned int n,
	    const sockaddr_in * addr) throw (unix_error);

#endif
