/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef SERVER_LISTENER_HPP
#define SERVER_LISTENER_HPP

#include <netinet/in.h>

#include "errors.hpp"
#include "server_queue.hpp"

class AE_queue;

int	server_start_listening(const struct sockaddr_in &addr)
	    throw (unix_error);

struct server_listener_args {
	server_listener_args(AE_queue &ae_queue, Server_queue &server_queue,
	    int sock) :
		ae_queue(ae_queue),
		server_queue(server_queue),
		sock(sock)
	{}

	AE_queue &ae_queue;
	Server_queue &server_queue;
	int sock;
};
void	*server_listener(void *voidarg);

#endif
