/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef SERVER_WORKER_HPP
#define SERVER_WORKER_HPP

#include "server_queue.hpp"
#include "server_table.hpp"
#include "http.hpp"
#include "server_comm.hpp"

struct server_worker_args {
	server_worker_args(Server_table &servers, Server_queue &queue,
	    unsigned worker_number, Segment_owner_map &segment_owner_map,
		Segment_map &segment_map) :
		servers(servers),
		queue(queue),
		worker_number(worker_number),
		segment_owner_map(segment_owner_map),
		segment_map(segment_map)
	{}

	Server_table		&servers;
	Server_queue		&queue;
	unsigned		worker_number;
	Segment_owner_map	&segment_owner_map;
	Segment_map		&segment_map;

};
void handle_request(const Http_request *req, Server_table &server_table, std::string name, Segment_owner_map &segment_owner_map, Segment_map &segment_map, int fd) throw (request_restart);
void	*server_worker(void *voidargs);

#endif
