/* Copyright 2010 Markus Peloquin <markus@cs.wisc.edu>,
 * Lena Olson <lena@cs.wisc.edu>, Jeffery Roller <roller-j@cs.wisc.edu>
 *
 * You can't do anything with this but read and execute it privately.  If you
 * want to do more, ask us if we'd be willing to make a more permissive
 * license. */

#ifndef UTIL_HPP
#define UTIL_HPP

#include <arpa/inet.h>
#include <netinet/in.h>

#include <sstream>
#include <string>

inline std::string addr_to_str(const struct sockaddr_in &addr)
{
	char addrbuf[INET_ADDRSTRLEN+1];
	inet_ntop(AF_INET, &addr.sin_addr, addrbuf, INET_ADDRSTRLEN);

	std::ostringstream out;
	out << addrbuf << ':' << ntohs(addr.sin_port);
	return out.str();
}

#endif
